"""
Models used by /business-model-server1-1

generated by model_code_gen.py
  - **filename** : ``business_model.py``
  - **json timestamp** : ``2023-03-02 16:19:07``
"""


from deepfos.api.models.base import BaseModel
from typing import List, Optional, Union, Any, Dict
from pydantic import Field


__all__ = [
    'ApprovalButton',
    'BusinessFormAccessControl',
    'BusinessModelApproveDTO',
    'BusinessModelApproveListDTO',
    'ColumnAliasDTO',
    'DataTableIndexDTO',
    'ElementDetailDTO',
    'ModelDataColumnsDTO',
    'ModelDataNoChildTableDTO',
    'ModelDataSaveErrorMsgDTO',
    'OperateRecordResponseVO',
    'PartitionDTO',
    'PermissionDataDTO',
    'PermissionPartitionDTO',
    'PermissionSaveDTO',
    'RoleColumnDTO',
    'SegmentDTO',
    'StatusColumnDTO',
    'StructureAssociationDTO',
    'StructureRedundantDTO',
    'UserDetailDTO',
    'ApprovalRecordVo',
    'AuthorityPartitionDTO',
    'CustomOperationDTO',
    'ModelDataReturnDTO',
    'AuthorityDTO',
    'PermissionDTO',
    'BusinessModelDTOReq',
    'BusinessModelDTORes',
    'BusinessModelResultVO',
    'DataTableColumnDTO',
    'LogicTableColumnDTO',
    'LogicTableColumnDTOReq',
    'LogicTableColumnDTORes',
    'DataTableInfoDTO',
    'ModelDataSaveDTO',
    'ModelDataTableDTO',
    'StructureDTO',
    'StructureDTOReq',
    'StructureDTORes'
]


class ApprovalButton(BaseModel):
    #: 按钮描述
    description: Optional[str] = None
    #: 按钮id
    id: Optional[str] = None
    #: 是否提交操作标记
    isSubmit: Optional[bool] = None
    #: 按钮name
    name: Optional[str] = None


class BusinessFormAccessControl(BaseModel):
    """Business Form Access Control

    .. admonition:: 引用接口

        - **POST** ``/business/model/permission/field`` (Response: 200)
    """
    #: 权限 4 read,5 write
    accessRight: Optional[int] = None
    #: 所有角色
    allRoles: Optional[bool] = None
    #: 业务方主键
    businessId: Optional[str] = None
    #: 创建时间
    createTime: Optional[str] = None
    #: 创建人
    creater: Optional[int] = None
    #: 数据行序号(去重用的字段)
    dataNum: Optional[int] = None
    #: 数据表名
    datatableName: Optional[str] = None
    #: 唯一编码
    id: Optional[int] = None
    #: 修改时间
    modifyTime: Optional[str] = None
    #: 修改人
    modifyer: Optional[int] = None
    #: 值
    params: Optional[str] = None
    #: 值类型: OPERATION-操作、 ACCESS_CONTROL_UNIT-权限控制单元、FIELD-字段
    paramsType: Optional[str] = None
    #: 值
    paramsValue: Optional[str] = None
    #: 模型id
    partitionId: Optional[str] = None
    #: 角色编码
    role: Optional[str] = None
    #: 角色组编码
    rolegroup: Optional[str] = None
    #: 状态1
    status1: Optional[str] = None
    #: 状态2
    status2: Optional[str] = None
    #: 状态3
    status3: Optional[str] = None
    #: 状态4
    status4: Optional[str] = None
    #: 状态5
    status5: Optional[str] = None
    #: 数据表目录
    tableFolderId: Optional[str] = None


class BusinessModelApproveDTO(BaseModel):
    """Business Model Approve DTO

    .. admonition:: 引用接口

        - **POST** ``/business/model/approval-operation``
    """
    #: 业务模型对应文件夹id
    businessModelFolderId: str
    #: 业务模型名称
    businessModelName: str
    #: 业务模型对应文件夹
    businessModelPath: Optional[str] = None
    #: 业务模型主表主键
    mainModelPrimaryKey: Any
    #: 操作对应源状态
    originStatus: str
    #: 分区id
    partitionId: str
    #: 审批操作主键（为每个审批流对应子模型的主键）
    primaryKeyValue: Any
    #: 审批操作id
    processOperationId: str
    #: 备注信息
    remark: Optional[str] = None


class BusinessModelApproveListDTO(BaseModel):
    """Business Model Approve List DTO

    .. admonition:: 引用接口

        - **POST** ``/business/model/approval-records``
    """
    #: 业务模型对应文件夹id
    businessModelFolderId: str
    #: 业务模型名称
    businessModelName: str
    #: 业务模型对应文件夹
    businessModelPath: Optional[str] = None
    #: 业务模型主表主键
    mainModelPrimaryKey: Any
    #: 分区id
    partitionId: str
    #: 审批操作主键（为每个审批流对应子模型的主键）
    primaryKeyValue: Any


class ColumnAliasDTO(BaseModel):
    #: field
    field: Optional[str] = None
    #: id
    id: Optional[str] = None
    #: sort
    sort: Optional[str] = None
    #: viewKey
    viewKey: Optional[str] = None


class DataTableIndexDTO(BaseModel):
    #: 索引列信息
    indexColumns: Optional[List[str]] = None
    #: 索引名称
    indexName: Optional[str] = None
    #: 索引类型
    indexType: Optional[str] = None
    #: 唯一标识
    key: Optional[str] = None
    #: 索引操作
    operation: Optional[str] = None


class ElementDetailDTO(BaseModel):
    #: 是否绝对路径
    absoluteTag: Optional[bool] = None
    #: 元素名称
    elementName: Optional[str] = None
    #: 元素类型
    elementType: Optional[str] = None
    #: 目录id
    folderId: Optional[str] = None
    #: 元素绝对路径
    path: Optional[str] = None
    #: 元素相对路径
    relativePath: Optional[str] = None
    #: 组件id
    serverName: Optional[str] = None


class ModelDataColumnsDTO(BaseModel):
    #: 权限值
    accessRight: Optional[int] = None
    #: 字段全局唯一别名
    alias: Optional[ColumnAliasDTO] = None
    #: 字段名
    columnName: Optional[str] = None
    #: 原始字段值
    oldValue: Optional[Any] = None
    #: 字段值
    value: Optional[Any] = None


class ModelDataNoChildTableDTO(BaseModel):
    #: 字段属性
    columns: Optional[List[ModelDataColumnsDTO]] = None
    #: 公共字段别名
    commonColumnAlias: Optional[ColumnAliasDTO] = None
    #: 数据表名目录id
    dataTableFolderId: Optional[str] = None
    #: 数据表名
    dataTableName: Optional[str] = None
    #: 数据表路径
    dataTablePath: Optional[str] = None
    #: 业务主键
    logicKeyList: Optional[List[str]] = None
    #: 操作类型
    operateType: Optional[str] = None
    #: 父表业务主键字段值
    parentLogicKeyColumns: Optional[List[ModelDataColumnsDTO]] = None


class ModelDataSaveErrorMsgDTO(BaseModel):
    #: alias
    alias: Optional[ColumnAliasDTO] = None
    #: description
    description: Optional[str] = None
    #: msg
    msg: Optional[Any] = None


class OperateRecordResponseVO(BaseModel):
    """Operate Record Response VO

    .. admonition:: 引用接口

        - **POST** ``/business/model/approval-operation`` (Response: 200)
    """
    #: 错误信息，具体信息使用方自己决定
    errors: Optional[List[Any]] = None
    #: 成功失败标识
    success: Optional[bool] = None
    #: 警告信息，具体信息使用方自己决定
    warnings: Optional[List[Any]] = None


class PartitionDTO(BaseModel):
    """Partition DTO

    .. admonition:: 引用接口

        - **GET** ``/business/model/form/partitions`` (Response: 200)
    """
    #: 子模型描述
    description: Optional[Any] = None
    #: 子模型描述1
    description1: Optional[str] = None
    #: 子模型描述2
    description2: Optional[str] = None
    #: 子模型描述3
    description3: Optional[str] = None
    #: 子模型描述4
    description4: Optional[str] = None
    #: 子模型描述5
    description5: Optional[str] = None
    #: 子模型描述6
    description6: Optional[str] = None
    #: 子模型描述7
    description7: Optional[str] = None
    #: 子模型描述8
    description8: Optional[str] = None
    #: 子模型成员(成员唯一id)
    members: Optional[List[str]] = None
    #: 子模型id
    partitionId: Optional[str] = None
    #: 子模型名称
    partitionName: str
    #: 排序
    sort: Optional[int] = None
    #: 子模型主表在模型中唯一id
    uuid: Optional[str] = None


class PermissionDataDTO(BaseModel):
    #: add
    add: Optional[List[Any]] = None
    #: 原数据
    data: Optional[List[BusinessFormAccessControl]] = None
    #: delete
    delete: Optional[List[str]] = None
    #: pageNum
    pageNum: Optional[int] = None
    #: pageSize
    pageSize: Optional[int] = None
    #: roleStrategyId
    roleStrategyId: Optional[str] = None
    #: update
    update: Optional[List[Any]] = None


class PermissionPartitionDTO(BaseModel):
    #: 字段权限配置
    data: Optional[PermissionDataDTO] = None
    #: 操作权限配置
    operateData: Optional[PermissionDataDTO] = None
    #: 主/子模型编码
    partitionId: Optional[str] = None
    #: roleStatus
    roleStatus: Optional[str] = None
    #: statusSort
    statusSort: Optional[Any] = None
    #: type
    type: Optional[str] = None
    #: 权限控制单元权限配置
    unitData: Optional[PermissionDataDTO] = None


class PermissionSaveDTO(BaseModel):
    #: 业务模型名称
    businessName: Optional[str] = None
    #: 业务模型路径
    folderId: Optional[str] = None
    #: 主模型/子模型权限数据
    partitions: Optional[List[PermissionPartitionDTO]] = None


class RoleColumnDTO(BaseModel):
    #: 字段名
    columnName: Optional[str] = None
    #: 字段所属的数据表名
    dataTableName: Optional[str] = None
    #: 是否已选择作为角色字段
    isRoleColumn: Optional[int] = None
    #: 权限方案关联的维度名
    rsDimension: Optional[str] = None
    #: 关联权限方案的元素信息
    rsDimensionElementDetail: Optional[ElementDetailDTO] = None
    #: 权限方案关联的维度序号
    rsMapping: Optional[int] = None
    #: 字段的排序
    sort: Optional[int] = None
    #: 数据表所属的目录id
    tableFolderId: Optional[str] = None
    #: 数据表在当前模型的唯一编码
    uuid: Optional[str] = None


class SegmentDTO(BaseModel):
    #: 权限控制单元
    accessControlUnit: Optional[str] = None
    #: 是否启用权限控制
    enableAccessControl: Optional[bool] = None
    #: 是否逻辑主键
    isLogicKey: Optional[bool] = None
    #: 字段名
    seg: Optional[str] = None
    #: 是否提交必填
    submitRequired: Optional[bool] = None
    #: 字段类型(逻辑类型)
    valueType: Optional[int] = None


class StatusColumnDTO(BaseModel):
    #: 字段名
    columnName: Optional[str] = None
    #: 字段所属的数据表名
    dataTableName: Optional[str] = None
    #: 关联审批流或值列表的元素信息
    elementDetail: Optional[ElementDetailDTO] = None
    #: 是否已选择作为状态字段
    isStatusColumn: Optional[int] = None
    #: 字段关联的审批流描述
    pcDesc: Optional[str] = None
    #: 字段关联的审批流目录id
    pcFolderId: Optional[str] = None
    #: 字段关联的审批流名称
    pcName: Optional[str] = None
    #: 字段关联的值列表名称
    smartListName: Optional[str] = None
    #: 字段的排序
    sort: Optional[int] = None
    #: 字段所属的数据表目录id
    tableFolderId: Optional[str] = None
    #: 数据表在当前模型的唯一编码
    uuid: Optional[str] = None


class StructureAssociationDTO(BaseModel):
    #: 当前级表的字段名
    logicTableFk: Optional[str] = None
    #: 当前表的字段描述
    logicTableFkDes: Optional[str] = None
    #: 父级表的字段名
    parentPk: Optional[str] = None
    #: 父级表的字段描述
    parentPkDes: Optional[str] = None


class StructureRedundantDTO(BaseModel):
    #: 父级表的字段名
    parentSeg: Optional[str] = None
    #: 父级表的字段描述
    parentSegDes: Optional[str] = None
    #: 当前表的字段名
    seg: Optional[str] = None
    #: 当前表的字段描述
    segDes: Optional[str] = None


class UserDetailDTO(BaseModel):
    #: 是否管理员标识
    adminTag: Optional[str] = None
    #: 头像
    avatar: Optional[str] = None
    #: 邮箱
    email: Optional[str] = None
    #: 手机号
    mobilePhone: Optional[str] = None
    #: 昵称
    nickName: Optional[str] = None
    #: 状态
    status: Optional[str] = None
    #: 用户id
    userId: Optional[str] = None
    #: 用户名
    userName: Optional[str] = None


class ApprovalRecordVo(BaseModel):
    """Approval Record Vo

    .. admonition:: 引用接口

        - **POST** ``/business/model/approval-records`` (Response: 200)
    """
    #: 按钮
    buttons: List[ApprovalButton]
    #: 控制字段必填
    isSubmit: Optional[bool] = None
    #: 行号
    line_no: int
    #: 操作时间
    operate_time: str
    #: 操作人
    operate_user: str
    #: 审批备注
    pc_remark: str
    #: 业务主键字段(key为业务主键的key,value为业务主键对应的值)
    primaryKeyValue: Any
    #: 审批操作描述
    process_operation_des: str
    #: 审批操作id
    process_operation_id: str
    #: 随机码
    random_code: str
    #: 审批后的状态
    result_status: str
    #: 审批后的状态描述
    result_status_des: str
    #: 用户信息,用户不存在为null
    user_detail: Optional[UserDetailDTO] = None


class AuthorityPartitionDTO(BaseModel):
    #: 是否启用权限控制单元
    enableAccessUnit: Optional[bool] = None
    #: 子模型描述
    partitionDesc: Optional[str] = None
    #: 子模型编码
    partitionId: Optional[str] = None
    #: 子模型名称
    partitionName: Optional[str] = None
    #: 状态字段信息
    statusInfo: Optional[List[StatusColumnDTO]] = None


class CustomOperationDTO(BaseModel):
    #: 同步异步 0/1
    async_: int = Field(None, alias='async')
    #: PYTHON元素信息
    elementDetail: Optional[ElementDetailDTO] = None
    #: PYTHON元素名称
    name: Optional[str] = None
    #: 排序
    sort: Optional[int] = None
    #: 请求类型URL/PY
    type: str
    #: URL请求地址
    url: Optional[str] = None


class ModelDataReturnDTO(BaseModel):
    """Model Data Return DTO

    .. admonition:: 引用接口

        - **POST** ``/business/model/data/save`` (Response: 200)
    """
    #: 返回消息：error类型消息
    errors: Optional[List[ModelDataSaveErrorMsgDTO]] = None
    #: 传入的行业务数据
    mainKey: Optional[Any] = None
    #: 处理过程标签
    progressTag: Optional[int] = None
    #: 返回结果：true:成功、false:失败
    success: Optional[bool] = None
    #: 返回消息：warning类型消息
    warnings: Optional[List[ModelDataSaveErrorMsgDTO]] = None


class AuthorityDTO(BaseModel):
    """Authority DTO

    .. admonition:: 引用接口

        - **GET** ``/business/model/permission`` (Response: 200)
    """
    #: 业务模型目录id
    folderId: str
    #: 业务模型名称
    name: str
    #: 业务模型目录
    path: Optional[str] = None
    #: 角色字段信息
    roleColumn: Optional[List[RoleColumnDTO]] = None
    #: 角色方案元素信息
    rsElementDetail: Optional[ElementDetailDTO] = None
    #: 角色方案名称
    rsName: Optional[str] = None
    #: 状态字段信息
    statusColumn: Optional[List[AuthorityPartitionDTO]] = None


class PermissionDTO(BaseModel):
    """Permission DTO

    .. admonition:: 引用接口

        - **POST** ``/business/model/permission``
    """
    #: 模型分组信息
    business: Optional[AuthorityDTO] = None
    #: permission
    permission: Optional[PermissionSaveDTO] = None
    #: 权限信息
    permissions: Optional[PermissionSaveDTO] = None


class BusinessModelDTOReq(BaseModel):
    """Business Model DTO Req

    .. admonition:: 引用接口

        - **POST** ``/business/model``
    """
    #: 模型描述
    description: Optional[Any] = None
    #: 描述1
    description1: Optional[str] = None
    #: 描述2
    description2: Optional[str] = None
    #: 描述3
    description3: Optional[str] = None
    #: 描述4
    description4: Optional[str] = None
    #: 描述5
    description5: Optional[str] = None
    #: 描述6
    description6: Optional[str] = None
    #: 描述7
    description7: Optional[str] = None
    #: 描述8
    description8: Optional[str] = None
    #: 所属目录id
    folderId: str
    #: 业务模型唯一编码
    id: Optional[str] = None
    #: 主表信息
    logicTable: 'StructureDTOReq'
    #: 模型错误标记
    modelWarning: Optional[int] = None
    #: 组件id
    moduleId: Optional[str] = None
    #: 名称
    name: str
    #: 业务模型路径
    path: Optional[str] = None
    #: 权限配置数据
    permissionsData: Optional[List[BusinessFormAccessControl]] = None
    #: 删除后置
    postDeleteOpe: Optional[List[CustomOperationDTO]] = None
    #: 保存后置
    postSaveOpe: Optional[List[CustomOperationDTO]] = None
    #: 删除前置
    preDeleteOpe: Optional[List[CustomOperationDTO]] = None
    #: 保存前置
    preSaveOpe: Optional[List[CustomOperationDTO]] = None
    #: 是否修复缺失的数据表
    repairDataTable: Optional[bool] = None
    #: 保存类型:0-保存前校验,1-保存
    saveType: Optional[int] = None
    #: 子模型信息
    subModels: Optional[List[PartitionDTO]] = None
    #: 操作类型 ADD-新增，EDIT-编辑
    type: str


class BusinessModelDTORes(BaseModel):
    #: 模型描述
    description: Optional[Any] = None
    #: 描述1
    description1: Optional[str] = None
    #: 描述2
    description2: Optional[str] = None
    #: 描述3
    description3: Optional[str] = None
    #: 描述4
    description4: Optional[str] = None
    #: 描述5
    description5: Optional[str] = None
    #: 描述6
    description6: Optional[str] = None
    #: 描述7
    description7: Optional[str] = None
    #: 描述8
    description8: Optional[str] = None
    #: 所属目录id
    folderId: str
    #: 业务模型唯一编码
    id: Optional[str] = None
    #: 主表信息
    logicTable: 'StructureDTORes'
    #: 模型错误标记
    modelWarning: Optional[int] = None
    #: 组件id
    moduleId: Optional[str] = None
    #: 名称
    name: str
    #: 业务模型路径
    path: Optional[str] = None
    #: 权限配置数据
    permissionsData: Optional[List[BusinessFormAccessControl]] = None
    #: 删除后置
    postDeleteOpe: Optional[List[CustomOperationDTO]] = None
    #: 保存后置
    postSaveOpe: Optional[List[CustomOperationDTO]] = None
    #: 删除前置
    preDeleteOpe: Optional[List[CustomOperationDTO]] = None
    #: 保存前置
    preSaveOpe: Optional[List[CustomOperationDTO]] = None
    #: 是否修复缺失的数据表
    repairDataTable: Optional[bool] = None
    #: 保存类型:0-保存前校验,1-保存
    saveType: Optional[int] = None
    #: 子模型信息
    subModels: Optional[List[PartitionDTO]] = None
    #: 操作类型 ADD-新增，EDIT-编辑
    type: str


class BusinessModelResultVO(BaseModel):
    """Business Model Result VO

    .. admonition:: 引用接口

        - **GET** ``/business/model`` (Response: 200)
        - **POST** ``/business/model`` (Response: 200)
        - **POST** ``/business/model/relation`` (Response: 200)
    """
    #: 业务模型信息
    businessModel: Optional[BusinessModelDTORes] = None


class DataTableColumnDTO(BaseModel):
    #: 创建时间
    createTime: Optional[str] = None
    #: 创建人
    creator: Optional[str] = None
    #: 默认值
    defaultValue: Optional[str] = None
    #: 字段描述
    description: Optional[str] = None
    #: 创建时间
    lastModifyTime: Optional[str] = None
    #: 修改人
    lastModifyUser: Optional[str] = None
    #: 字段长度
    length: Optional[str] = None
    #: 字段名
    name: Optional[str] = None
    #: 更新前信息
    oldInfo: Optional['DataTableColumnDTO'] = None
    #: 操作类型
    operation: Optional[str] = None
    #: 排序
    sort: Optional[int] = None
    #: 字段类型
    type: Optional[str] = None
    #: 可否为空
    whetherEmpty: Optional[bool] = None
    #: 是否自增
    whetherIncrement: Optional[bool] = None
    #: 是否唯一
    whetherOnly: Optional[bool] = None
    #: 是否主键
    whetherPrimary: Optional[bool] = None
    #: 是否系统字段
    whetherSystemColumn: Optional[bool] = None


class LogicTableColumnDTO(BaseModel):
    """Logic Table Column DTO

    .. admonition:: 引用接口

        - **POST** ``/business/model/form/segment/column-name`` (Response: 200)
    """
    #: 列权限信息
    authority: Optional[SegmentDTO] = None
    #: 数据表列信息
    baseInfo: Optional[DataTableColumnDTO] = None
    #: columnName
    columnName: Optional[str] = None
    #: 列逻辑属性
    logicInfo: Optional[Any] = None


class LogicTableColumnDTOReq(BaseModel):
    #: 列权限信息
    authority: Optional[SegmentDTO] = None
    #: 数据表列信息
    baseInfo: Optional[DataTableColumnDTO] = None
    #: 列逻辑属性
    logicInfo: Optional[Any] = None


class LogicTableColumnDTORes(BaseModel):
    #: 列权限信息
    authority: Optional[SegmentDTO] = None
    #: 数据表列信息
    baseInfo: Optional[DataTableColumnDTO] = None
    #: columnName
    columnName: Optional[str] = None
    #: 列逻辑属性
    logicInfo: Optional[Any] = None


class DataTableInfoDTO(BaseModel):
    #: 实际表名
    actualTableName: Optional[str] = None
    #: 创建时间
    createTime: Optional[str] = None
    #: 创建人
    creator: Optional[str] = None
    #: 同步、异步
    dataSync: Optional[int] = None
    #: 多语言描述
    description: Optional[Any] = None
    #: 数据表描述1
    description1: Optional[str] = None
    #: 数据表描述2
    description2: Optional[str] = None
    #: 数据表描述3
    description3: Optional[str] = None
    #: 数据表描述4
    description4: Optional[str] = None
    #: 数据表描述5
    description5: Optional[str] = None
    #: 数据表描述6
    description6: Optional[str] = None
    #: 数据表描述7
    description7: Optional[str] = None
    #: 数据表描述8
    description8: Optional[str] = None
    #: 元素组件信息
    elementDetail: Optional[ElementDetailDTO] = None
    #: 数据表描述8
    folderId: Optional[str] = None
    #: 数据表id,传id为修改
    id: Optional[str] = None
    #: 最后修改时间
    lastModifyTime: Optional[str] = None
    #: 最后修改人
    lastModifyUser: Optional[str] = None
    #: 数据表组件id
    moduleId: Optional[str] = None
    #: 数据表名称
    name: str
    #: 修改前数据表信息
    oldInfo: Optional['DataTableInfoDTO'] = None


class ModelDataSaveDTO(BaseModel):
    """Model Data Save DTO

    .. admonition:: 引用接口

        - **POST** ``/business/model/data/data-consistency-deal``
        - **POST** ``/business/model/data/save``
    """
    #: 表单数据集合
    data: Optional[List['ModelDataTableDTO']] = None
    #: 数据库属性校验
    databaseCheck: Optional[bool] = None
    #: 元素名称
    elementName: str
    #: 是否需要进行字段权限校验
    fieldCheck: Optional[bool] = None
    #: 文件夹id
    folderId: str
    #: 是否需要处理（关联关系、冗余字段等默认为true
    formatData: Optional[bool] = None
    #: 逻辑属性校验
    logicCheck: Optional[bool] = None
    #: 主键集合
    mainKeyList: Optional[List[Any]] = None
    #: 元素名称
    path: Optional[str] = None
    #: 保存后置触发开关
    savePost: Optional[bool] = None
    #: 保存前置触发开关
    savePre: Optional[bool] = None


class ModelDataTableDTO(BaseModel):
    #: 子表数据
    children: Optional[List['ModelDataTableDTO']] = None
    #: 字段属性
    columns: Optional[List[ModelDataColumnsDTO]] = None
    #: 公共字段别名
    commonColumnAlias: Optional[ColumnAliasDTO] = None
    #: 数据表名目录id
    dataTableFolderId: Optional[str] = None
    #: 数据表名
    dataTableName: Optional[str] = None
    #: 数据表路径
    dataTablePath: Optional[str] = None
    #: 业务主键
    logicKeyList: Optional[List[str]] = None
    #: 模型主表基本信息
    modelMainTableDTO: Optional[ModelDataNoChildTableDTO] = None
    #: 操作类型
    operateType: Optional[str] = None
    #: 父表业务主键字段值
    parentLogicKeyColumns: Optional[List[ModelDataColumnsDTO]] = None
    #: 父级表数据信息
    parentTableInfo: Optional[ModelDataNoChildTableDTO] = None


class StructureDTO(BaseModel):
    """Structure DTO

    .. admonition:: 引用接口

        - **GET** ``/business/model/authority/partition/structure/top`` (Response: 200)
        - **GET** ``/business/model/authority/partition/structures`` (Response: 200)
        - **GET** ``/business/model/authority/partition/structures/enable-access-unit`` (Response: 200)
        - **POST** ``/business/model/form/structure/table-name`` (Response: 200)
        - **GET** ``/business/model/form/structure/top`` (Response: 200)
        - **GET** ``/business/model/form/structures`` (Response: 200)
        - **POST** ``/business/model/form/structures/column`` (Response: 200)
        - **POST** ``/business/model/form/structures/module`` (Response: 200)
    """
    #: 父子表关联关系
    associations: Optional[List[StructureAssociationDTO]] = None
    #: 子级表列表
    children: Optional[List['StructureDTO']] = None
    #: 数据表列信息
    columns: List[LogicTableColumnDTO]
    #: 与父表的数据关系
    dataRelation: Optional[str] = None
    #: 数据表详情
    dataTableInfo: DataTableInfoDTO
    #: 数据表名称
    dataTableName: str
    #: 数据表类型
    dataTableType: Optional[str] = None
    #: 数据表索引列集合DTO
    datatableIndexInfo: Optional[List[DataTableIndexDTO]] = None
    #: 数据表文件夹id
    folderId: Optional[str] = None
    #: 是否子模型主表
    keyTable: Optional[bool] = None
    #: 当前表层级
    level: int
    #: 业务主键
    logicKeyList: Optional[List[str]] = None
    #: 当前模型中父级表的唯一id
    parentUuid: Optional[str] = None
    #: 数据表路径
    path: Optional[str] = None
    #: 记录创建人、创建时间
    recordCreate: Optional[bool] = None
    #: 记录修改人、修改时间
    recordModify: Optional[bool] = None
    #: 冗余字段
    redundantSegList: Optional[List[StructureRedundantDTO]] = None
    #: 层级表关联信息
    relationField: Optional[str] = None
    #: 系统主键
    systemPrimaryKey: Optional[str] = None
    #: 唯一字段
    uniqueSegList: Optional[List[List]] = None
    #: 当前模型中数据表的唯一id
    uuid: str
    #: 是否创建排序字段
    whetherSort: Optional[bool] = None


class StructureDTOReq(BaseModel):
    #: 父子表关联关系
    associations: Optional[List[StructureAssociationDTO]] = None
    #: 子级表列表
    children: Optional[List['StructureDTOReq']] = None
    #: 数据表列信息
    columns: List[LogicTableColumnDTOReq]
    #: 与父表的数据关系
    dataRelation: Optional[str] = None
    #: 数据表详情
    dataTableInfo: DataTableInfoDTO
    #: 数据表名称
    dataTableName: str
    #: 数据表类型
    dataTableType: Optional[str] = None
    #: 数据表索引列集合DTO
    datatableIndexInfo: Optional[List[DataTableIndexDTO]] = None
    #: 数据表文件夹id
    folderId: Optional[str] = None
    #: 是否子模型主表
    keyTable: Optional[bool] = None
    #: 当前表层级
    level: int
    #: 业务主键
    logicKeyList: Optional[List[str]] = None
    #: 当前模型中父级表的唯一id
    parentUuid: Optional[str] = None
    #: 数据表路径
    path: Optional[str] = None
    #: 记录创建人、创建时间
    recordCreate: Optional[bool] = None
    #: 记录修改人、修改时间
    recordModify: Optional[bool] = None
    #: 冗余字段
    redundantSegList: Optional[List[StructureRedundantDTO]] = None
    #: 层级表关联信息
    relationField: Optional[str] = None
    #: 系统主键
    systemPrimaryKey: Optional[str] = None
    #: 唯一字段
    uniqueSegList: Optional[List[List]] = None
    #: 当前模型中数据表的唯一id
    uuid: str
    #: 是否创建排序字段
    whetherSort: Optional[bool] = None


class StructureDTORes(BaseModel):
    #: 父子表关联关系
    associations: Optional[List[StructureAssociationDTO]] = None
    #: 子级表列表
    children: Optional[List['StructureDTORes']] = None
    #: 数据表列信息
    columns: List[LogicTableColumnDTORes]
    #: 与父表的数据关系
    dataRelation: Optional[str] = None
    #: 数据表详情
    dataTableInfo: DataTableInfoDTO
    #: 数据表名称
    dataTableName: str
    #: 数据表类型
    dataTableType: Optional[str] = None
    #: 数据表索引列集合DTO
    datatableIndexInfo: Optional[List[DataTableIndexDTO]] = None
    #: 数据表文件夹id
    folderId: Optional[str] = None
    #: 是否子模型主表
    keyTable: Optional[bool] = None
    #: 当前表层级
    level: int
    #: 业务主键
    logicKeyList: Optional[List[str]] = None
    #: 当前模型中父级表的唯一id
    parentUuid: Optional[str] = None
    #: 数据表路径
    path: Optional[str] = None
    #: 记录创建人、创建时间
    recordCreate: Optional[bool] = None
    #: 记录修改人、修改时间
    recordModify: Optional[bool] = None
    #: 冗余字段
    redundantSegList: Optional[List[StructureRedundantDTO]] = None
    #: 层级表关联信息
    relationField: Optional[str] = None
    #: 系统主键
    systemPrimaryKey: Optional[str] = None
    #: 唯一字段
    uniqueSegList: Optional[List[List]] = None
    #: 当前模型中数据表的唯一id
    uuid: str
    #: 是否创建排序字段
    whetherSort: Optional[bool] = None


BusinessModelDTOReq.update_forward_refs()
BusinessModelDTORes.update_forward_refs()
DataTableColumnDTO.update_forward_refs()
DataTableInfoDTO.update_forward_refs()
ModelDataSaveDTO.update_forward_refs()
ModelDataTableDTO.update_forward_refs()
StructureDTO.update_forward_refs()
StructureDTOReq.update_forward_refs()
StructureDTORes.update_forward_refs()
